//==============================================================
// IR wave recoder Ver1.00    (STPP.03)
//     for PSP CFW3.80 M33-5 + 1.50 Kernel addon (PSP-1000p)
// STEAR 2008,2009
//--------------------------------------------------------------
// IR wave viewer̔hAvŁAԊOMMđL^肷
// @\t́B
// wK^R̃TvIȂ̂łB
// IrDÃ{[[gύX邽߃n[h𒼐ڂĂ̂ŃJ[l[h
// œĂ܂B
//
// Ver1.00Simple IMEɂ閼̓͂ɑΉB
//--------------------------------------------------------------

#include <pspkernel.h>
#include <psppower.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <pspsystimer.h>
#include <psputility.h>
#include <string.h>

#include "zenkaku.h"
#include "serialport.h"
#include "rawir.h"
#include "draw.h"
#include "sime.h"

//----- }N -----


//----- 萔ݒ -----

#define IRBUFSIZE	5*40000										// IRMobt@TCY (5bԕ)
#define CORLINE		0x80C080									// r
#define CORTITLE	0x507050									// ^Cgwi
#define CORROLLBAR	0x90FF90									// XN[o[
#define CORLOW		0x204000									// LOW
#define CORHI		0x8080FF									// HI
#define CORREC		0x906090									// M
#define CORERR		0x4040A0									// G[_CAO
#define CORSELECT	0x704040									// I_CAO
#define CORKEY		0xA0A0A0									// _CAO
#define CORBBAK		0x202020									// {^wi
#define CORBCUR		0xD04040									// {^J[\
#define CORSBAK		0x204030									// Rʔwi
#define CORSTIT		0x305030									// Rʃ^uwi

#define RAWSIZE		300											// L^łg`̍ő
#define IRFILE		"IRWAVE.DAT"								// ۑ鎞̃t@C
#define TABMAX		8											// ^ǔ

//----- vg^Cv錾 -----

//- VXe֘A -

int		SetupCallbacks(void);
int		callbackThread(SceSize args, void *argp);
int		exitCallback(int arg1, int arg2, void *common);
int		power_callback(int unknown, int pwrflags, void *common);

//- ̑ -

void	ScrDraw(int tab,int x,int y);
void	menu(int btn);
void	BtnRec(int no);
void	IrSend(int btn);
int		InputName(char *title,int size,char *inStr,char *outStr);
int		SelectHz(int btn);
int		IrRec(int btn);
void	WaveDraw(long DrawPos,int Range);
void	RollBar(long pos,int range);
void	RangeDraw(int range);
void	PacketDraw(int range);
void	WaveLog(void);
void	ValDraw3(int x,int y,int va);
void	SetIrBPS(void);
int		timer_handler(void);

//------ O[oϐ -----

static SceSysTimerId gTimer;
static volatile unsigned char gIrWave[IRBUFSIZE];				// IRMobt@(Oobt@)
static unsigned int __attribute__((aligned(16))) gList[262144];
static volatile int	gExitRequest = 0,
					gResumeFlag = 0,
					gBlankTime = 400,							// t[Ԋu
					gIrStartFlag;								// L^Jn^C~Op
static volatile long gIWPosT,gIWSize;							// IRMobt@̃|C^
static volatile long gAnchor1 = 0,gAnchor2 = 0;					// AJ[|Cg

struct {
	int		len;												// g`f[^̃TCY (0:f[^)
	int		frq;												// gg
	u32		raw_buffer[RAWSIZE];								// g`f[^
	char	name[33];											// {^
} gRaw[30*TABMAX];												// e{^ɓo^ꂽg`f[^

struct {
	char	name[33];											// ^u
	int		frq;												// ftHgg
} gTab[TABMAX];

//------ s[hw -----

PSP_MODULE_INFO("IRRecorder", 0x1000, 1, 1);					// J[l[h
PSP_MAIN_THREAD_ATTR(0);
PSP_MAIN_THREAD_STACK_SIZE_KB(32);
PSP_HEAP_SIZE_KB(-1024);


//==============================================================
// ԊOf[^̏
//--------------------------------------------------------------

void InitData(void)
{
	int i;

	memset(gTab, 0, sizeof(gTab));
	memset(gRaw, 0, sizeof(gRaw));
	for (i=0; i<TABMAX ;i++)
		gTab[i].name[0] = '1' + i;
}

//==============================================================
// main
//--------------------------------------------------------------

int	main(int argc,char **argv)
{
	SceCtrlData	pad;
	int			fd,ret,x,y,tab,key,draw;

	SetupCallbacks();

	sceGuInit();
	sceGuStart(GU_DIRECT, gList);
	sceGuDrawBuffer(GU_PSM_8888, SCRBUF0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, SCRBUF0, BUF_WIDTH);
	sceGuFinish();
	sceGuSync(0, 0);
	sceDisplayWaitVblankStart();
	sceGuDisplay(GU_TRUE);

	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(PSP_CTRL_MODE_DIGITAL);

	//----- f[^t@Cǂݍ -----

	fd = sceIoOpen(IRFILE, PSP_O_RDONLY, 0777);					// f[^ǂݍ
	if (fd >= 0){
		ret = sceIoRead(fd, gTab, sizeof(gTab));
		ret += sceIoRead(fd, gRaw, sizeof(gRaw));
		sceIoClose(fd);
		if (ret != sizeof(gTab)+sizeof(gRaw)){					// TCYȂNA
			InitData();
		}
	} else {
		InitData();
	}

	//----- Simple IMEZbgAbv -----

	mh_print(0, 0, "t@C[h", 0xFFFFFF);
	ret = InitSIME(0);											// ǂݍ݂Ɗe평iwi̎ȕ[hj
	switch(ret){
	case 1:
		mh_print(0, 13, "sȎt@CłB", 0xFFFFFF);
		break;
	case 2:
		mh_print(0, 13, "ȂĎǂ߂܂łB", 0xFFFFFF);
		break;
	case 3:
		mh_print(0, 13, "iSIME.DICj܂B", 0xFFFFFF);
		break;
	}
	if (ret){													// G[Ă
		mh_print(0, 26, "ϊ@\\gpo܂B", 0xFFFFFF);
		while(SIMEgetchar(pad)==0 && !gExitRequest){			// ܂őҋ@
			sceCtrlReadBufferPositive(&pad, 1);
			sceDisplayWaitVblankStart();
		}
	}
	BoxClr(0, 0, 480, 39);

	//----- C -----

	tab = 0;
	x = 0;
	y = 0;
	ScrDraw( tab,x,y );											// ʍ\z
	draw = 0;
	while(!gExitRequest){
		sceCtrlReadBufferPositive(&pad, 1);
		key = SIMEgetchar(pad);
		if (key==SIME_KEY_UP){									// switchŋLqcaseSȏ̏ꍇIrRec()sceSTimerAlloc()scH
			y--;
			if (y<0) y = 9;
			draw = 1;
		} else if (key==SIME_KEY_DOWN){
			y++;
			if (y>9) y = 0;
			draw = 1;
		} else if (key==SIME_KEY_LEFT){
			x--;
			if (x<0) x = 2;
			draw = 1;
		} else if (key==SIME_KEY_RIGHT){
			x++;
			if (x>2) x = 0;
			draw = 1;
		} else if (key==SIME_KEY_TRIANGLE){
		} else if (key==SIME_KEY_CROSS){
		} else if (key==SIME_KEY_SQUARE){
		} else if (key==SIME_KEY_CIRCLE){						// L[s[gIRM
			IrSend(tab*30+x*10+y);
		} else if (key==SIME_KEY_LTRIGGER){
			tab--;
			if (tab<0) tab = TABMAX-1;
			draw = 1;
		} else if (key==SIME_KEY_RTRIGGER){
			tab++;
			if (tab>TABMAX-1) tab = 0;
			draw = 1;
		} else if (key==SIME_KEY_START){						// j[
			menu(tab*30+x*10+y);
			draw = 1;
		}
		if (pad.Buttons & PSP_CTRL_SQUARE){						// AM
			IrSend(tab*30+x*10+y);
		}

		if (draw){
			ScrDraw( tab,x,y );									// {^̓o^󋵂XV
			draw = 0;
		}
		sceDisplayWaitVblankStart();
	}

	//----- I -----

	EndSIME();													// Simple IMEI
	sceGuTerm();
	sceKernelExitGame();
	sceKernelSleepThread();
	return (0);
}


//==============================================================
// {^Sė܂őҋ@
//--------------------------------------------------------------

void popKey(void)
{
	SceCtrlData	pad;

	while (1){
		sceCtrlReadBufferPositive(&pad, 1);
		if (!(pad.Buttons & 0x0FFFF))
			break;
		sceDisplayWaitVblankStart();
	}
}

//==============================================================
// Cʂ̍\z
//--------------------------------------------------------------

void ScrDraw(int tab,int x,int y)
{
	int			i,j,xx,yy;
	long		cor;

	mh_print(  0, FONTHEIGHT*0, "IR wave recorder Ver1.00", 0xFFFFFF);
	mh_print(190, FONTHEIGHT*0, "[START]FMenu   :IR Send", 0x707070);
	mh_print(400, FONTHEIGHT*0, "(c)STEAR 2009", 0x707070);

	CurveBox( 10,50,460,212,CORSBAK );
	BoxClr( 140,26,200,12 );
	xx = strlen(gTab[tab].name)*FONTWIDTH;
	mh_print( 240-xx/2,26,gTab[tab].name,0xFFFFFF );
	HLine ( 140,40,200,0xA0A0A0 );

	for (i=0; i<3 ;i++){
		for (j=0; j<10 ;j++){										// o^f[^̕\
			yy = 60 + j*20;
			if (i==x && j==y){
				cor = CORBCUR;
			} else {
				cor = CORBBAK;
			}
			CurveBox( 30 +i*150, yy-2, FONTWIDTH*20,FONTHEIGHT+4,cor);
			if (gRaw[tab*30+i*10+j].len){
				xx = strlen(gRaw[tab*30+i*10+j].name)*FONTWIDTH;
				mh_print( 30 +i*150+(120-xx)/2, yy, gRaw[tab*30+i*10+j].name, 0xFFFFFF);
			}
		}
	}
}

//==============================================================
// ԊOf[^̕ۑ
//--------------------------------------------------------------

void dataSave(void)
{
	int			fd;
	SceCtrlData	pad;

	BoxFill(149,87,182,32,CORLINE,CORSELECT);					// bZ[W_CAO
	mh_print(159,97,"t@C֕ۑĂ܂", 0xFFFFFF);

	fd = sceIoOpen(IRFILE, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, 0777);
	if (fd>=0){													// f[^ۑ
		sceIoWrite(fd, gTab, sizeof(gTab));
		sceIoWrite(fd, gRaw, sizeof(gRaw));
		sceIoClose(fd);
	} else {
		BoxFill(140,80,200,46,CORLINE,CORERR);					// bZ[W_CAO
		mh_print(150,90,"t@Cւ̕ۑɎs܂", 0xFFFFFF);
		mh_print(222,104,"OKF", CORKEY);
		popKey();												// {^܂őҋ@
		while(SIMEgetchar(pad)==0 && !gExitRequest){			// ܂őҋ@
			sceCtrlReadBufferPositive(&pad, 1);
			sceDisplayWaitVblankStart();
		}
	}
}

//==============================================================
// j[\
//--------------------------------------------------------------

void menuDraw(int cur,int btn)
{
	const char item[5][13] = {"ԊOo^","^Cg","폜","{^ύX","gύX"};
	int		i;
	long	cor;

	BoxFill(198,80,84,88,CORLINE,CORTITLE);					// bZ[W_CAO
	for (i=0; i<5 ;i++){
		if (cur==i)
			BoxFill(204,86+i*16,72,12,CORBCUR,CORBCUR);
		cor = 0xFFFFFF;
		if (gRaw[btn].len==0 && i>1)
			cor = 0x808080;
		mh_print( 204+(72-strlen(item[i])*6)/2, 86+i*16, item[i], cor );
	}
}

//==============================================================
// j[
//--------------------------------------------------------------

void menu(int btn)
{
	SceCtrlData	pad;
	int ret,key,cur;

	cur = 0;
	menuDraw( cur,btn );
	popKey();

	//----- ڑI -----

	while (!gExitRequest){
		sceCtrlReadBufferPositive(&pad, 1);
		key = SIMEgetchar(pad);
		if (key==SIME_KEY_UP){
			cur--;
			if (cur < 0) cur = 4;
			menuDraw( cur,btn );
		} else if (key==SIME_KEY_DOWN){
			cur++;
			if (cur > 4) cur = 0;
			menuDraw( cur,btn );
		} else if (key==SIME_KEY_CIRCLE){						// 
			if (!(gRaw[btn].len==0 && cur>1))
				break;
		} else if (key==SIME_KEY_CROSS){						// LZ
			cur = -1;
			break;
		}
		sceDisplayWaitVblankStart();
	}
	if (gExitRequest) return;
	popKey();

	//----- ڏ -----

	ret = -1;
	if (cur==0){												// L^[h
		BtnRec(btn);
	} else if (cur==1){											// ^CgύX
		ret = InputName("^Cĝ͂Ă",32,gTab[btn/30].name,gTab[btn/30].name);
	} else if (cur==2){											// 폜
		gRaw[btn].len = 0;
		gRaw[btn].name[0] = '\0';
		ret = 0;
	} else if (cur==3){											// {^ύX
		ret = InputName("{^̂͂Ă",20,gRaw[btn].name,gRaw[btn].name);
	} else if (cur==4){											// gύX
		ret = SelectHz(btn);
	}
	if (ret>=0)
		dataSave();												// f[^ۑ
	popKey();
}

//==============================================================
// ԊOM̓o^
//--------------------------------------------------------------
// ̂ƐԊOM̎荞݂s܂B
// 擾f[^͂̂ǃ[XeBbNɋL^܂B
// L^f[^鎖͍lĂ܂B
//--------------------------------------------------------------

void BtnRec(int btn)
{
	popKey();													// {^܂őҋ@
	if (!IrRec(btn)){											// Mg`L^
		InputName("{^̂͂Ă",20,gRaw[btn].name,gRaw[btn].name);
		dataSave();
	}

	popKey();													// {^܂őҋ@
	BoxClr(0,0,SCR_WIDTH,SCR_HEIGHT);							// ʃNA
}


//==============================================================
// Sp/p肠ňꕶ
//--------------------------------------------------------------

int INBack(char *str,int pos)
{
	int pos2,step;

	if (pos>0){
		pos2 = 0;
		while (1){
			if (chkSJIS(str[pos2])){
				step = 2;
			} else {
				step = 1;
			}
			if (pos2+step>=pos) break;
			pos2 += step;
		}
		pos = pos2;
	}
	return (pos);
}

//==============================================================
// 
//--------------------------------------------------------------
// title  ^Cg
// size   ͗̕iőRQ܂Łj
// inStr  ͕̏l
// outStr ͌
// ߂l 0   :{^ŏI
//        ȊO:~{^ŃLZꂽ
//--------------------------------------------------------------
// Simple IME𗘗pėpPC͂łB
// {^ŏIꍇAoutStrɓ͕񂪕ԂB
// ~{^ŏIꍇAoutStrɂinStrԂB
//--------------------------------------------------------------

int InputName(char *title,int size,char *inStr,char *outStr)
{
	SceCtrlData pad;
	char	str[33],cr[33];
	int		i,cx,cy,x,pos,len,p,dr,end;

	if (size>32) size = 32;

	SIMEcursor( 2,&cx,&cy );									// J[\̏ݒ

	//----- _CAO\z -----

	BoxFill(  132,60,216,41,CORLINE,CORSELECT );				// bZ[W_CAO
	x = 132 + 216/2 - strlen(title)*FONTWIDTH/2;
	mh_print( x,65,title, 0xFFFFFF );
	x = 132 + 216/2 - (size*FONTWIDTH+2)/2;						// ͗ʒu
	BoxFill(  x,81,size*FONTWIDTH+2,14,0,0 );
	x += 1;
	cy = 82;
	strcpy( str,inStr );										// ̏l
	len = strlen(str);
	pos = len;
	mh_print( x,cy,str, 0xFFFFFF );

	//----- ͏ -----

	end = 1;
	while (!gExitRequest && end){
		cx = x + pos * FONTWIDTH;
		sceCtrlReadBufferPositive( &pad,1 );
		SIMEgets( cr,pad );
		if (cr[0]!=0){											// ͂
			dr = 0;												// 邩i0:Noj
			if (cr[0]<32U){										// Rg[R[hꍇ
				switch(cr[0]){
				case SIME_KEY_CIRCLE:							//  [Enter]
					end = 0;
					break;
				case SIME_KEY_CROSS:							// ~ [ESC]
					end = 0;
					break;
				case SIME_KEY_UP:								// igpj
					break;
				case SIME_KEY_DOWN:								// igpj
					break;
				case SIME_KEY_LEFT:								// 
					pos = INBack( str,pos );
					break;
				case 0x08:										// [BS]
					if (len>0){
						pos = INBack( str,pos );
						if (chkSJIS(str[pos])){
							strcpy( &str[pos],&str[pos+2] );
							len -= 2;
						} else {
							strcpy( &str[pos],&str[pos+1] );
							len -= 1;
						}
						dr = 1;
					}
					break;
				case SIME_KEY_RIGHT:							// 
					if (chkSJIS(str[pos])){
						pos += 2;
					} else {
						if (pos<len){
							pos++;
						}
					}
					break;
				}
			} else {											// ꍇ
				p = 0;
				while (cr[p]!='\0'){
					if (chkSJIS(cr[p])){						// Sp
						if (len<=30){
							for (i=0; i<len-pos ;i++)
								str[len-1+2-i] = str[len-1-i];
							str[pos++] = cr[p++];
							str[pos++] = cr[p++];
							len += 2;
							dr = 1;
						} else {
							break;
						}
					} else {									// p
						if (len<=31){
							for (i=0; i<len-pos ;i++)
								str[len-1+1-i] = str[len-1-i];
							str[pos++] = cr[p++];
							len += 1;
							dr = 1;
						} else {
							break;
						}
					}
				}
				str[len] = '\0';
			}
			if (dr){											// ̍XV
				BoxClr( x,cy,size*FONTWIDTH,12 );
				mh_print( x,cy, str, 0xFFFFFF);
			}
		}

		sceDisplayWaitVblankStart();
	}

	//----- ߂l -----

	if (cr[0]==0x0D){											// [Enter]ŏIĂ
		strcpy( outStr,str );
		return (0);
	} else {
		strcpy( outStr,inStr );
		return (-1);
	}
}

//==============================================================
// gg̑I̕\
//--------------------------------------------------------------

void SelectHzDraw(int x)
{
	BoxFill(140,80,200,50,CORLINE,CORSELECT);					// bZ[W_CAO
	mh_print(156, 90,"ggIł", 0xFFFFFF);
	BoxFill(171 + x * 36,108,34,13,CORBCUR,CORBCUR);
	mh_print(174,109,"36kHz 38kHz 40kHz 42kHz", 0xFFFFFF);
}

//==============================================================
// gg̑I
//--------------------------------------------------------------

int SelectHz(int btn)
{
	SceCtrlData		pad;
	int x,key;

	if (gRaw[btn].len==0){
		x = gTab[btn/30].frq;
	} else {
		x = (gRaw[btn].frq - 36) / 2;
	}

	SelectHzDraw(x);
	popKey();													// {^܂őҋ@
	while (!gExitRequest){
		sceCtrlReadBufferPositive(&pad, 1);
		key = SIMEgetchar(pad);
		if (key==SIME_KEY_LEFT){
			x--;
			if (x < 0) x = 3;
			SelectHzDraw(x);
		} else if (key==SIME_KEY_RIGHT){
			x++;
			if (x > 3) x = 0;
			SelectHzDraw(x);
		} else if (key==SIME_KEY_CIRCLE){						// 
			gRaw[btn].frq = 36 + x * 2;							// gg
			break;
		} else if (key==SIME_KEY_CROSS){						// LZ
			x = -1;
			break;
		}
		sceDisplayWaitVblankStart();
	}
	if (x>=0) gTab[btn/30].frq = x;
	popKey();													// {^܂őҋ@
	return (x);
}

//==============================================================
// ԊOM̎荞
//--------------------------------------------------------------
// IR wave viewerقڂ̂܂܁B
// Ōɔg`f[^̉͂ǉB
//
// ߂lF0:o^ -1:LZꂽ
//--------------------------------------------------------------

//----- vg^Cv -----

int	IrRecSet(int btn,int log1,long count,int rPos);

//----- C -----

int IrRec(int btn)
{
	unsigned char	data[20];
	int				x,fd,range,padPush,mode,log1,log2,rPos;
	long			i,pos,sum,count;
	SceCtrlData		pad;

	//----- ʍ\z -----

	BoxClr(0,0,SCR_WIDTH,SCR_HEIGHT);							// ʃNA

	mh_print(  0, FONTHEIGHT*0, "ԊOf[^M", 0x8080FF);
	mh_print(130, FONTHEIGHT*0, ":PAUSE :F.BLANK :Record ~:CANCEL :ݼޕύX", 0x707070);

	BoxFill(0,15,70,16,CORLINE,CORTITLE);						// Mf[^
	BoxFill(0,30,SCR_WIDTH,9,CORLINE,0x000000);					// Mf[^XN[o[
	VLine(  0, 37,33,CORLINE);									// Mf[^
	VLine(479, 37,33,CORLINE);									// Mf[^
	BoxFill(0,89,70,16,CORLINE,CORTITLE);						// t[^Cg
	BoxFill(0,104,SCR_WIDTH,15,CORLINE,0x000000);				// t[
	BoxFill(0,122,70,16,CORLINE,CORTITLE);						// O^Cg
	BoxFill(0,137,SCR_WIDTH,135,CORLINE,CORLOW);				// O

	mh_print(  3, 17, "Mf[^", 0xFFFFFF);
	mh_print( 90, 17, "W:", 0xFFFFFF);
	mh_print(170, 17, "MW:", 0xFFFFFF);
	mh_print(  3, 91, "t[", 0xFFFFFF);
	mh_print( 90, 91, "t[Ԋu:000ms", 0xFFFFFF);
	ValDraw3( 90+ FONTWIDTH*13, 91, gBlankTime/40);				// t[Ԋu\
	mh_print(  3, 124, "Log", 0xFFFFFF);
	RangeDraw(0);												// Wƃ[[̕\̓ϐZbg
	range = 1;
	RangeDraw(range);											// Wƃ[[̕\

	//----- ݒ -----

	gAnchor1 = 0;
	gAnchor2 = 0;
	memset((char*)gIrWave, 0, IRBUFSIZE);						// Mobt@NA
	gIrStartFlag = 0;											// 0ȂIRHI͂܂ŃTvOsȂ
	gIWPosT = 0;												// IrWave擪ʒu
	gIWSize = 0;												// IrWaveTCY

	fd = sceIoOpen("irda0:", PSP_O_RDWR, 0);					// IrDAI[v
	SetIrBPS();													// BPS1500000֕ύX
	serialport_read(&psprc_serialport, data, 20,1);				// IR FIFONA
	gTimer = sceSTimerAlloc();
	sceSTimerSetHandler(gTimer, 4194303/4000, timer_handler, 0);	//0.025[ms]PʂIRTvO
	sceSTimerStartCount(gTimer);

	//----- C -----

	popKey();													// {^܂őҋ@

	mode = 0;													// 0:M 1:g`\
	padPush = 0;												// z^Ă邩 0:No 1:Yes
	pos = 0;													// Mf[^\ʒu
	while(!gExitRequest){
		if (gResumeFlag){										// W[ꂽ
			gResumeFlag = 0;
			SetIrBPS();											// BPS1500000֕ύX
		}
		sceCtrlReadBufferPositive(&pad, 1);
		if (pad.Buttons & PSP_CTRL_SQUARE){						// 荞݊
			break;
		}
		if (pad.Buttons & PSP_CTRL_CROSS){						// LZ
			mode = -1;
			break;
		}
		if (pad.Buttons & PSP_CTRL_TRIANGLE && padPush == 0){
			gBlankTime += 40;									// t[ԊuԐ؂ւ
			if (gBlankTime > 800) gBlankTime = 40;
			ValDraw3(90+ FONTWIDTH *13, 91, gBlankTime/40);		// t[Ԋu\
			if (mode) PacketDraw(range);						// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_CIRCLE && padPush == 0){		// [hύX
			if (mode){
				BoxClr(0,0,FONTWIDTH*18,FONTHEIGHT);
				mh_print(0, FONTHEIGHT*0,"ԊOf[^M", CORHI);
				BoxClr(170+ FONTWIDTH*9, 17, FONTWIDTH *3, FONTHEIGHT);
				sceSTimerStartCount(gTimer);					// IRTvOJn
				mode = 0;
				padPush = 1;
				pos = 0;
			} else {
				BoxClr(0, 0, FONTWIDTH *18, FONTHEIGHT);
				mh_print(0, FONTHEIGHT*0, "g`\\", 0xFF8080);
				sceSTimerStopCount(gTimer);						// IRTvO~
				mode = 1;
				padPush = 1;
				pos = 0;
				sum = 0;
				count = 1;
				for (i=0; i<IRBUFSIZE ;i++)						// MW̏Wv
					if (gIrWave[i] != 0){
						sum += gIrWave[i];
						count++;
					}
				sum = sum * 100 / count;
				ValDraw3(170+ FONTWIDTH *9, 17, sum);
			}
		}
		if (pad.Buttons & PSP_CTRL_UP && padPush == 0){
			range++;
			if (range > 99) range = 99;
			PacketDraw(range);									// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_DOWN && padPush == 0){
			range--;
			if (range < 1) range = 1;
			PacketDraw(range);									// t[̓\
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_LEFT){
			pos += 1 * range;
			if (pos > gIWSize) pos = gIWSize;
		}
		if (pad.Buttons & PSP_CTRL_RIGHT){
			pos -= 1 * range;
			if (pos < 0) pos = 0;
		}
		if (pad.Buttons & PSP_CTRL_LTRIGGER && padPush == 0){
			pos += 350 * range;
			if (pos > gIWSize) pos = gIWSize;
			padPush = 1;
		}
		if (pad.Buttons & PSP_CTRL_RTRIGGER && padPush == 0){
			pos -= 350 * range;
			if (pos < 0) pos = 0;
			padPush = 1;
		}
		if (!(pad.Buttons & 0x0FFF0))							// {^ĂȂ
			padPush = 0;

		RollBar(pos, range);									// XN[o[
		RangeDraw(range);										// Wƃ[[̕\
		WaveDraw(pos, range);									// ԊOg`
		if (!mode){
			PacketDraw(range);									// t[̓\
			WaveLog();											// Mf[^O
		}
		sceDisplayWaitVblankStart();
	}
	sceSTimerStopCount(gTimer);									// IRTvO~
	sceSTimerFree(gTimer);
	sceIoClose(fd);
	if (gExitRequest || mode == -1) return (-1);				// LZꂽ

	//----- gI -----

	x = SelectHz(btn);											// gI_CAO
	if (gExitRequest || x == -1) return (-1);					// LZꂽ
	

	//----- f[^ -----

	if (gAnchor1 == gAnchor2) return (-1);						// t[擾ĂȂ
	pos = gAnchor1;
	log1 = 1;													// ŏ͕KHI
	count = 0;													// g (TvOƑMtick܂ܓ̂ŊZ͂ĂȂ)
	for (rPos = 0; rPos < 9 ;rPos++)							// _~[f[^ (8ԖڂŖȃEFCgcsircstH[}bg̗݂H)
		gRaw[btn].raw_buffer[rPos] = IR_SIGNAL_OFF(1);
	while (pos != gAnchor2){
		count++;
		pos++;
		if (pos >= IRBUFSIZE) pos -= IRBUFSIZE;
		log2 = (gIrWave[pos]) ? 1 : 0;
		if (log1 != log2){										// ω_
			rPos = IrRecSet(btn, log1, count, rPos);			// gf[^
			count = 0;
			log1 = log2;
		}
		if (rPos >= RAWSIZE) break;								// obt@Ȃ̂Œf
	}
	rPos = IrRecSet(btn, log1, count, rPos);					// gf[^
	gRaw[btn].len = rPos;
	return (0);													// o^
}

//--------------------------------------------------------------
// Mobt@ɔgf[^Zbg
//--------------------------------------------------------------
// 0.025[ms]Pʂ̔gf[^SendRawIR()ň`ɕϊăobt@Ɋi[B
//--------------------------------------------------------------

int IrRecSet(int btn,int HiLow,long count,int rPos)
{
	while (1){													// 255Pʂŕ
		if (count < 256){
			gRaw[btn].raw_buffer[rPos++] = (HiLow) ? IR_SIGNAL_ON(count) : IR_SIGNAL_OFF(count);
			break;
		} else {
			gRaw[btn].raw_buffer[rPos++] = (HiLow) ? IR_SIGNAL_ON(255) : IR_SIGNAL_OFF(255);
			count -= 255;
		}
		if (rPos >= RAWSIZE) break;								// obt@Ȃ
	}
	return (rPos);
}

//==============================================================
// ԊOM̑M
//--------------------------------------------------------------
// w肳ꂽԍ̐ԊOM𑗐MB
// w肳ꂽԍ̃f[^ꍇ͉ȂB
// gςƔɑM̐M̒ςĂ܂܂A덷͈̔
// ĂƂŕ␳͂Ă܂B
//--------------------------------------------------------------

void IrSend(int btn)
{
	RAW_IR_DATA	irdata;

	if (gRaw[btn].len == 0) return;								// f[^o^ĂȂ

	irdata.timing_val = gRaw[btn].frq / 2;						// ggݒ
	irdata.raw_buffer = gRaw[btn].raw_buffer;					// 40kHz1tick0.025[ms]
	irdata.raw_count = gRaw[btn].len;
	SendRawIR(&irdata, 1);										// ԊOf[^M
}

//==============================================================
// ԊOg`̍
//--------------------------------------------------------------

void WaveDraw(long DrawPos,int Range)
{
	long pos,poss,len,cor;
	int i,x,sum,cnt;

	pos = gIWPosT - 1;
	len = gIWSize;
	if (DrawPos > len) DrawPos = len;
	pos -= DrawPos;
	if (pos < 0) pos += IRBUFSIZE;
	len -= DrawPos;
	x = SCR_WIDTH -1;
	while(x>1){
		if (len <= 0){
			BoxClr(1,40,x-1,30);								// ]vȃS~͏
			break;
		}
		sum = 0;
		cnt = 0;
		poss = pos;
		for (i=0; i<Range ;i++){								// Range͈̔͂̃f[^̕ς𒲂ׂ
			sum += gIrWave[poss];
			if (gIrWave[poss]) cnt++;
			poss--;
			if (poss < 0) poss += IRBUFSIZE;
		}
		if (cnt)
			sum = (sum+cnt-1) / cnt;							// _ȉ؂グ
		else
			sum = 0;
		for (i=0; i<16 ;i++)									// M
			VRAM[55-i][x-1] = (sum==0 || i>sum*3) ? CORLOW : CORREC;
		cor = (sum==0) ? CORLOW : CORHI;
		for (i=0; i<13 ;i++)									// Mg`
			VRAM[57+i][x-1] = cor;
		pos -= Range;
		if (pos < 0) pos += IRBUFSIZE;
		len -= Range;
		x--;
	}
}

//==============================================================
// XN[o[̕\
//--------------------------------------------------------------

void RollBar(long pos,int range)
{
	int i;
	long len,p;
	static long lenBuf = 0,pBuf = 0;

	if (gIWSize == 0)
		p = 0;
	else
		p = pos * (SCR_WIDTH -2) / gIWSize;
	if (gIWSize == 0)
		len = SCR_WIDTH -2;
	else
		len = (SCR_WIDTH -1) * SCR_WIDTH * range / gIWSize;
	if (len > (SCR_WIDTH -2)) len = SCR_WIDTH -2;				// ʂ͂ݏoꍇ̕␳
	if (p + len > (SCR_WIDTH -2)) p = SCR_WIDTH -2 - len;		// ʂ͂ݏoꍇ̕␳

	if (lenBuf == len && pBuf == p) return;						// OƓȂ悵Ȃ
	lenBuf = len;
	pBuf = p;

	for (i=0; i<7 ;i++){										// XN[o[
		HLine(1,31+i,SCR_WIDTH-2,CORTITLE);						// x
		HLine(SCR_WIDTH-1 -p -len,31+i,len,CORROLLBAR);			// V㏑
	}
}

//==============================================================
// W̕\ƃXP[̕\
//--------------------------------------------------------------

void RangeDraw(int range)
{
	static int bak = 0;
	int a,i,x;

	if (bak == range) return;									// Kv̖Ƃ͏Ȃ
	bak = range;
	if (range == 0) return;										// W͈͊O

	ValDraw3(90+FONTWIDTH*7,17,range);							// W

	BoxClr(0,70,480,FONTHEIGHT+3);
	for (i=0; i<SCR_WIDTH ;i++){								// ڈ
		VRAM[70][i] = CORLINE;
		if (i %  4 == 0) VRAM[70 +1][i] = 0xFFFFFF;
		if (i % 20 == 8) VRAM[70 +2][i] = 0xFFFFFF;
		if (i % 40 == 8) VRAM[70 +3][i] = 0xFFFFFF;
	}
	x = 8;
	a = 0;
	while(x<SCR_WIDTH){											// XP[̒l
		ValDraw3(x-8,70 +5,a);
		x += 40;
		a += range;
	}
	mh_print(465,70 + 5,"ms", 0xFFFFFF);
}

//==============================================================
// t[̓\
//--------------------------------------------------------------
// t[̓́uԊO͂̃TvOvłĂ܂B
// obt@̃f[^ɍ悵Ă邽߁Aobt@NAƕ\
// ܂B
//--------------------------------------------------------------

void PacketDraw(int range)
{
	int  x;
	long pos,len;

	if (gAnchor1 > gAnchor2)
		len = (gAnchor2 + IRBUFSIZE) - gAnchor1;
	else
		len = gAnchor2 - gAnchor1;
	len = len / range + 1;										// \t[̃TCY

	pos = gAnchor1;
	for (x=1; x<SCR_WIDTH-1 ;x++){
		if ((x-1) <= len)										// t[
			VLine(x, 105, 13, (gIrWave[pos] == 0) ? CORLOW : CORHI);
		else													// t[O
			VLine(x, 105, 13, 0);
		pos += range;
		if (pos >= IRBUFSIZE) pos -= IRBUFSIZE;
	}
}

//==============================================================
// Mf[^̃TlC
//--------------------------------------------------------------
// Mobt@̓e1/3ɏkĉʂɕ\Ă܂B
// ԕׂ鏈B
//--------------------------------------------------------------

void WaveLog(void)
{
	const long cor[] = {CORLOW,0x3030B0,0x7070E0,0x9090FF,0xB0B0FF,0xE0E0FF};
	      long i,j,pos;

	pos = gIWPosT;
	for (i=SCR_HEIGHT-1; i>138 ;i--)
		for (j=SCR_WIDTH-1; j>1 ;j--){
			VRAM[i-1][j-1] = cor[gIrWave[pos]];
			pos -=3;
			if (pos < 0) pos += IRBUFSIZE;
		}
}

//==============================================================
// wʒuɐl`(3)
//--------------------------------------------------------------
// 3ȏ̐lw肳ꂽꍇ͉3\܂B
// wi͏܂B
// ȈՓIȎłB
//--------------------------------------------------------------

void ValDraw3(int x,int y,int va)
{
	char s[4];

	s[0] = '0' + ((va / 100) % 10);
	s[1] = '0' + ((va /  10) % 10);
	s[2] = '0' + ((va /   1) % 10);
	s[3] = 0;
	BoxClr(x,y,FONTWIDTH*3,FONTHEIGHT);
	mh_print(x,y, s, 0xFFFFFF);
}

//==============================================================
// ԊO͂̃TvO
//--------------------------------------------------------------
// 0.025[ms]IrDA|[gǂ݁Af[^ΐԊOHÍAf[^
// LOW͂ƔfAʂgIrWave[]ɋL^܂B
// ̃TvOƒIHI͂r؂Ă܂̂ŕԏ
// ܂B
// gIrWave[]̓e
//     0 : LOW
//     1 : ԂꂽHI
//     2 : HI (M1)
//     3 : HI (M2)
//     4 : HI (M3)
//     5 : HI (M4ȏ)
// ԂHI͎̕ώM𒲂ׂΐԊOgg𐄑łƎvǁA
// ǂ낤H
// ŐṼf[^gIWPosT-1̈ʒuɂAɌgIWSizef[^
// ܂B(0Ȃf[^)
// Oobt@Ȃ̂gIWSizeIRBUFSIZEɒBĂ܂ƈԌÂ
// f[^㏑Ă܂B
//
// gIrStartFlag0̎LOWf[^͓ǂݔ΂܂B܂HI͑҂ԂłB
//
// 莞Ԉȏ̖MԂĂHI͂AMt[
// JnʒuƔfAJ[ݒuĂ܂B
// ÕAJ[ʒu獡̃AJ[ʒu܂łMt[PɂȂł
// At[̕ԂK؂ɐݒ肵ȂƂƃt[ołȂ̂
// ӂKvBit[̋󔒎Ԃ͒At[ԊԊu͒Zj
//--------------------------------------------------------------

int	timer_handler(void)
{
	static unsigned char	data[20];
	static int				len,buf[3];
	static long				pos,ancCnt = 0,ancBuf;

	len = serialport_read(&psprc_serialport, data, 20,1);
	if (len) gIrStartFlag = 1;									// HI͂L^Jn
	if (gIrStartFlag){
		if (len>5) len = 5;
		buf[0] = buf[1];
		buf[1] = buf[2];
		buf[2] = len;
		if (len) len++;
		if (buf[0]!=0 && buf[1]==0 && buf[2]!=0 && gIWSize>2){	// HI͕ (HI,LOW,HI̕тɂȂLOWHIɒu)
			pos = gIWPosT - 1;
			if (pos < 0) pos += IRBUFSIZE;						// Oobt@̋E
			gIrWave[pos] = 1;
		}
		gIrWave[gIWPosT] = len;

		pos = gIWPosT - 1;										// t[̊Jnʒu
		if (pos < 0) pos += IRBUFSIZE;
		if (gIrWave[gIWPosT] != 0){
			if (gIrWave[pos] == 0){								// LOWHI
				if (ancCnt >= gBlankTime){						// LOW莞Ԉȏ㑱Ă
					ancBuf = gIWPosT;							// t[Jnʒu
				}
				ancCnt = 0;
			}
		} else {
			ancCnt++;											// LOW̎ԂJEg
			if (ancCnt == gBlankTime){							// LOW莞ԑ
				gAnchor1 = ancBuf;
				gAnchor2 = gIWPosT;								// t[IʒuɃAJ[Zbg
				if (gAnchor2 < 0) gAnchor2 += IRBUFSIZE;
			}
		}

		gIWPosT++;
		if (gIWPosT >= IRBUFSIZE) gIWPosT -= IRBUFSIZE;
		gIWSize++;
		if (gIWSize >= IRBUFSIZE) gIWSize = IRBUFSIZE;
	}
	return (-1);
}

//==============================================================
// IrDA|[gBPSύX
//--------------------------------------------------------------
// IrDA|[g͂OPEN9600bpsɐݒ肳Ă̂Aꂾ
// \SȂ̂Ő퓮삷͈͓ŎvグĂ܂B
// XԊORIrDA̕ϒɂ͌݊̂IrDA̋KiȂĖ
// łB
//--------------------------------------------------------------

void SetIrBPS(void)
{
	serialport_setspeed(&psprc_serialport,1500000);				// BPS1500000֕ύX
}

//==============================================================
// Exit callback
//--------------------------------------------------------------

int exit_callback(int arg1, int arg2, void *common)
{
	gExitRequest = 1;
	return (0);
}

//==============================================================
// Power callback
//--------------------------------------------------------------
// d֘ÃCxg
//--------------------------------------------------------------

int power_callback(int unknown, int pwrflags, void *common)
{
	if (pwrflags & PSP_POWER_CB_RESUME_COMPLETE){				// W[
		gResumeFlag = 1;
	}

    sceDisplayWaitVblankStart();

	return (0);
}

//==============================================================
// Callback thread
//--------------------------------------------------------------

int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
    cbid = sceKernelCreateCallback("Power Callback", power_callback, NULL);
    scePowerRegisterCallback(0, cbid);

	sceKernelSleepThreadCB();

	return (0);
}

//==============================================================
// Sets up the callback thread and returns its thread id
//--------------------------------------------------------------

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, THREAD_ATTR_USER, 0);
	if(thid >= 0){
		sceKernelStartThread(thid, 0, 0);
	}

	return (thid);
}
